<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'

import { type Product } from '../types/Product'
import type { VForm } from 'vuetify/components'

import http from '@/services/http'

//store
import { useProductStore } from '@/stores/product'
import { useCategoryStore } from '@/stores/category'
import category from '@/services/category'
import { useSubCategoryStore } from '@/stores/subCategory'
import { useSizeStore } from '@/stores/size'

const productStore = useProductStore()
const categoryStore = useCategoryStore()
const subCategoryStore = useSubCategoryStore()
const sizeStore = useSizeStore()

const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Unit',
    key: 'unit',
    value: 'unit'
  },
  {
    title: 'Category',
    key: 'category',
    value: 'category.name'
  },
  {
    title: 'Sub category',
    key: 'subCategory',
    value: (item: any | Product) => {
      if (item.subCategorys && item.subCategorys.length > 0) {
        return item.subCategorys.map((r: any) => r.name).join(', ')
      } else {
        return '-'
      }
    }
  },
  {
    title: 'Size',
    key: 'size',
    value: (item: any | Product) => {
      if (item.sizes && item.sizes.length > 0) {
        return item.sizes.map((r: any) => r.name).join(', ')
      } else {
        return '-'
      }
    }
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function onSubmit() {
  // Implement your form submission logic here
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await categoryStore.getCategorys()
  await subCategoryStore.getSubCategorys()
  await sizeStore.getSizes()
})

function closeDialog() {
  productStore.dialog = false
  nextTick(() => {
    productStore.clearForm()
  })
}
</script>

<template>
  <div>
    <br />
    <v-data-table :headers="headers" :items="productStore.products">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Products</v-toolbar-title>
          <v-divider
            class="mx-4 border-opacity-75"
            inset
            vertical
            thickness="2"
            color="white"
          ></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="productStore.dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props" icon="mdi-account-plus" class="bg-white">
              </v-btn>
            </template>
            <v-card style="background-color: #fff5e8">
              <v-card-title>
                <span class="text-h5">Product Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="productStore.editedProduct.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="productStore.editedProduct.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="productStore.editedProduct.unit"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Unit"
                          single-line
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Category"
                          :items="categoryStore.categorys"
                          item-title="name"
                          item-value="id"
                          :return-object="true"
                          v-model="productStore.editedProduct.category"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-if="productStore.checkDrink()"
                          label="Sub Category"
                          :items="subCategoryStore.subCategorys"
                          item-title="name"
                          item-value="id"
                          :return-object="true"
                          multiple
                          v-model="productStore.editedProduct.subCategorys"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-if="productStore.checkDrink()"
                          label="Size"
                          :items="sizeStore.sizes"
                          item-title="name"
                          item-value="id"
                          :return-object="true"
                          multiple
                          v-model="productStore.editedProduct.sizes"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-row>
                          <v-img
                            :src="
                              'http://localhost:3000/images/products/' +
                              productStore.editedProduct.image
                            "
                            width="200"
                            height="200"
                          >
                          </v-img>
                        </v-row>
                        <v-row>
                          <v-file-input
                            v-model="productStore.editedProduct.files"
                            :rules="[
                              (value) => {
                                return (
                                  !value ||
                                  !value.length ||
                                  value[0].size < 2000000 ||
                                  'Avatar size should be less than 2 MB!'
                                )
                              }
                            ]"
                            accept="image/png, image/jpeg"
                            placeholder="Pick an avatar"
                            prepend-icon="mdi-image"
                            label="Avatar"
                            variant="outlined"
                          ></v-file-input>
                        </v-row>
                      </v-col>
                    </v-row>
                    <v-row>
                      <UploadProductImage></UploadProductImage>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="productStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="productStore.closeDelete()"
                  >Cancel</v-btn
                >
                <v-btn
                  color="blue-darken-1"
                  variant="text"
                  @click="productStore.deleteItemConfirm()"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <div>{{ item.id }}</div>
        <v-icon size="small" class="me-2" @click="productStore.editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="productStore.deleteItem(item)"> mdi-delete </v-icon>
      </template>

      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/products/' + item.image" width="100px">{{
          console.log(item.image)
        }}</v-img>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="productStore.getProducts"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>


<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table-data {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
